// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

#[cfg(feature = "v3_32")]
#[cfg_attr(docsrs, doc(cfg(feature = "v3_32")))]
use glib::signal::{connect_raw, SignalHandlerId};
use glib::{prelude::*, translate::*};
#[cfg(feature = "v3_32")]
#[cfg_attr(docsrs, doc(cfg(feature = "v3_32")))]
use std::mem::transmute;
use std::{boxed::Box as Box_, fmt, pin::Pin, ptr};

glib::wrapper! {
    #[doc(alias = "DzlDirectoryReaper")]
    pub struct DirectoryReaper(Object<ffi::DzlDirectoryReaper, ffi::DzlDirectoryReaperClass>);

    match fn {
        type_ => || ffi::dzl_directory_reaper_get_type(),
    }
}

impl DirectoryReaper {
    #[doc(alias = "dzl_directory_reaper_new")]
    pub fn new() -> DirectoryReaper {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::dzl_directory_reaper_new()) }
    }

    //#[doc(alias = "dzl_directory_reaper_add_directory")]
    //pub fn add_directory(&self, directory: &impl IsA<gio::File>, min_age: /*Ignored*/glib::TimeSpan) {
    //    unsafe { TODO: call ffi:dzl_directory_reaper_add_directory() }
    //}

    //#[doc(alias = "dzl_directory_reaper_add_file")]
    //pub fn add_file(&self, file: &impl IsA<gio::File>, min_age: /*Ignored*/glib::TimeSpan) {
    //    unsafe { TODO: call ffi:dzl_directory_reaper_add_file() }
    //}

    //#[doc(alias = "dzl_directory_reaper_add_glob")]
    //pub fn add_glob(&self, directory: &impl IsA<gio::File>, glob: &str, min_age: /*Ignored*/glib::TimeSpan) {
    //    unsafe { TODO: call ffi:dzl_directory_reaper_add_glob() }
    //}

    #[doc(alias = "dzl_directory_reaper_execute")]
    pub fn execute(
        &self,
        cancellable: Option<&impl IsA<gio::Cancellable>>,
    ) -> Result<(), glib::Error> {
        unsafe {
            let mut error = ptr::null_mut();
            let is_ok = ffi::dzl_directory_reaper_execute(
                self.to_glib_none().0,
                cancellable.map(|p| p.as_ref()).to_glib_none().0,
                &mut error,
            );
            debug_assert_eq!(is_ok == glib::ffi::GFALSE, !error.is_null());
            if error.is_null() {
                Ok(())
            } else {
                Err(from_glib_full(error))
            }
        }
    }

    #[doc(alias = "dzl_directory_reaper_execute_async")]
    pub fn execute_async<P: FnOnce(Result<(), glib::Error>) + 'static>(
        &self,
        cancellable: Option<&impl IsA<gio::Cancellable>>,
        callback: P,
    ) {
        let main_context = glib::MainContext::ref_thread_default();
        let is_main_context_owner = main_context.is_owner();
        let has_acquired_main_context = (!is_main_context_owner)
            .then(|| main_context.acquire().ok())
            .flatten();
        assert!(
            is_main_context_owner || has_acquired_main_context.is_some(),
            "Async operations only allowed if the thread is owning the MainContext"
        );

        let user_data: Box_<glib::thread_guard::ThreadGuard<P>> =
            Box_::new(glib::thread_guard::ThreadGuard::new(callback));
        unsafe extern "C" fn execute_async_trampoline<
            P: FnOnce(Result<(), glib::Error>) + 'static,
        >(
            _source_object: *mut glib::gobject_ffi::GObject,
            res: *mut gio::ffi::GAsyncResult,
            user_data: glib::ffi::gpointer,
        ) {
            let mut error = ptr::null_mut();
            let _ =
                ffi::dzl_directory_reaper_execute_finish(_source_object as *mut _, res, &mut error);
            let result = if error.is_null() {
                Ok(())
            } else {
                Err(from_glib_full(error))
            };
            let callback: Box_<glib::thread_guard::ThreadGuard<P>> =
                Box_::from_raw(user_data as *mut _);
            let callback: P = callback.into_inner();
            callback(result);
        }
        let callback = execute_async_trampoline::<P>;
        unsafe {
            ffi::dzl_directory_reaper_execute_async(
                self.to_glib_none().0,
                cancellable.map(|p| p.as_ref()).to_glib_none().0,
                Some(callback),
                Box_::into_raw(user_data) as *mut _,
            );
        }
    }

    pub fn execute_future(
        &self,
    ) -> Pin<Box_<dyn std::future::Future<Output = Result<(), glib::Error>> + 'static>> {
        Box_::pin(gio::GioFuture::new(self, move |obj, cancellable, send| {
            obj.execute_async(Some(cancellable), move |res| {
                send.resolve(res);
            });
        }))
    }

    #[cfg(feature = "v3_32")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_32")))]
    #[doc(alias = "remove-file")]
    pub fn connect_remove_file<F: Fn(&Self, &gio::File) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn remove_file_trampoline<
            F: Fn(&DirectoryReaper, &gio::File) + 'static,
        >(
            this: *mut ffi::DzlDirectoryReaper,
            file: *mut gio::ffi::GFile,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this), &from_glib_borrow(file))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"remove-file\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    remove_file_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl Default for DirectoryReaper {
    fn default() -> Self {
        Self::new()
    }
}

impl fmt::Display for DirectoryReaper {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("DirectoryReaper")
    }
}
